# -*- coding: utf-8 -*-

#選択している頂点（1個）の法線を、線形状にして選択頂点から生やします
#線形状の名前の頭には「法線情報」と付加
#「選択頂点を法線方向にそって移動」スクリプトの「方向を指定」オプションを補佐するためのスクリプトです。
#上位パートに変換マトリクスがかかっていると法線の方向がおかしくなる場合があります。
#法線の長さは、選択頂点からポリゴンメッシュの中心座標への距離を参考に適当に設定

#動作条件
#選択形状がポリゴンメッシュ
#編集モードに入っている
#頂点編集モードに入っている
#頂点が一つのみ選択状態で作動





dousasuru=0


if xshade.scene().is_modify_mode==True and xshade.scene().active_shape().type==7 and xshade.scene().selection_mode == 2:
  if xshade.scene().active_shape().number_of_active_control_points==1:
    dousasuru=1


if dousasuru==1:
  #選択されている頂点の番号を割り出し
  for i in range(xshade.scene().active_shape().total_number_of_control_points):
    if xshade.scene().active_shape().vertex(i).active_order>0:
      activepoint=i
      break

  #法線情報と頂点の位置情報を格納
  vnormal=xshade.scene().active_shape().vertex(activepoint).normal
  vposition=xshade.scene().active_shape().vertex(activepoint).position
  centerp=xshade.scene().active_shape().center_point
  kyori=pow((vposition[0]-centerp[0])**2+(vposition[1]-centerp[1])**2+(vposition[1]-centerp[1])**2,0.5)
  nagasa=kyori/3

  #線形状を作成
  xshade.scene().begin_creating()
  xshade.scene().begin_line(None, False) 
  xshade.scene().append_point([vnormal[0]*nagasa+vposition[0],vnormal[1]*nagasa+vposition[1],vnormal[2]*nagasa+vposition[2]], None, None, None, None)
  offset=0
  xshade.scene().append_point([vposition[0]+vnormal[0]*offset,vposition[1]+vnormal[1]*offset,vposition[2]+vnormal[2]*offset], None, None, None, None)
  xshade.scene().end_line()
  xshade.scene().end_creating() 

  #線形状の名前を変更して兄（ポリゴンメッシュ）に戻って編集モードに入る
  xshade.scene().active_shape().name='法線情報_'+xshade.scene().active_shape().name
  xshade.scene().active_shape().modifiable=0 #これを0にして編集不可にしないとポリゴンメッシュの頂点選択の時に邪魔をする
  xshade.scene().select_sister()
  xshade.scene().enter_modify_mode()






